// FLIGHT IN HAWAII (PC88/2DD) t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "d88.h"

static unsigned char dir[0x100*16];				// Directory (256byte x 15sector)
static unsigned char buff[0x100*16*160];		// 256byte x 16sector x 160track
static char fname[FILENAME_MAX];				// ؂ot@C

D88 disk;
FILE *fp;

// wordlϐɑ
int getword(unsigned char *_p)
{
	int ret;
	ret = (_p[1]<<8) + _p[0];
	return ret;
}

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	int i,fn,yy,mm,dd;
	int trk,sec,start,end,size;

	if (argc < 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);

	// fBNg̓ǂݍ
	memset(dir, 0, sizeof(dir));
	if (disk.ReadDATA(0x01, 0x00, 0x01, 0x01, 0x01, dir, sizeof(dir)) != sizeof(dir)) {
		fprintf(stderr, "fBNg̓ǂݍ݂Ɏs܂.\n");
		return 1;
	}

	for (fn=0; fn<(sizeof(dir)/0x20); fn++)
	{
		unsigned char *ent = &dir[fn*0x20];
		if (ent[0] == 0x00) break;		// fBNg̍Ō

		char fname[FILENAME_MAX];		// t@C

		int i;
		int fnp = 0;
		for (i=0; i<16; i++)
		{
			char c = ent[i+1];		// t@CPo
			if (c == 0x0d) break;
			fname[fnp++] = c;		// t@C\
		}
		fname[fnp++] = '\0';		// ̍Ō

		trk  = ent[0x1e];
		sec  = ent[0x1f];
		yy   = ent[0x1a];
		mm   = ent[0x1b];
		dd   = ent[0x1c];
		size = getword(&ent[0x14]);

		// ؂o
		if (fcut(fname, trk, trk>>1, trk&1, sec, 0x01, 0, size)) {
			printf("%-16s %02x/%02x/%02x TRK:%02X SEC:%02X SIZE:%04X\n",fname,yy,mm,dd,trk,sec,size);
		}
	}
	return 0;
}
